Index: main/trunk/greenstone2/runtime-src/src/corba/corbaServer.mpp
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbaServer.mpp	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbaServer.mpp	(revision 25231)
@@ -1,5 +1,7 @@
+#define USE_POA
+
 // Standard headers
-#include <iostream.h>
-#include <fstream.h>
+#include <iostream>
+#include <fstream>
 
 // protocol headers
@@ -44,5 +46,5 @@
       here ++;
     }
-  cout << "Terminfo " << i << endl;
+  std::cout << "Terminfo " << i << std::endl;
 }
 
@@ -57,5 +59,5 @@
       corbaconv_text_t::setCorbatext(option.value,corba[i].value);
 
-      // cout << corbatext_string(corba[i].name) << "?" << option
+      // std::cout << corbatext_string(corba[i].name) << "?" << option
 
       array.push_back(option);
@@ -63,5 +65,7 @@
 }
 
-class corbaServer : virtual public corbaiface_skel
+// corbaServer no longer inherits from corbaiface_skel since the change from using 
+// BOA to POA in the Corba code upon updating Mico from version 2.3.5 to 2.3.13.
+class corbaServer : virtual public POA_gsdlInterface::corbaiface
 {
 private:
@@ -88,17 +92,17 @@
     char * cdirname;
 
-    cout << "CorbaServer: gsdlhome = " << home << endl;
+    std::cout << "CorbaServer: gsdlhome = " << home << std::endl;
 
     this->gsdlhome = home;
-    cout << gsdlhome.getcstr() << endl;
+    std::cout << gsdlhome.getcstr() << std::endl;
     dirname = filename_cat(gsdlhome, "/collect");
     cdirname = dirname.getcstr();
     if (!read_dir (cdirname, collections)) {
-      cout << "Unable to read the gsdl directory; terminating" << endl;
+      std::cout << "Unable to read the gsdl directory; terminating" << std::endl;
       exit (1);
     }
     delete cdirname;
 
-    cout << "Constructing set list server" << endl;
+    std::cout << "Constructing set list server" << std::endl;
     this->protocol = protocol;
 
@@ -128,10 +132,10 @@
 
       // ****
-      cout << "Recieved " << key << " = ";
+      std::cout << "Recieved " << key << " = ";
       for (int unsigned i=0; i<cfgline.size(); i++)
 	{
-	  cout << cfgline[i] << " ";
-	}
-      cout << endl;
+	  std::cout << cfgline[i] << " ";
+	}
+      std::cout << std::endl;
 
       // DB // ****
@@ -140,5 +144,5 @@
 	  text_tarray cfgline;
 	  cfgline.push_back (gsdlhome);
-	  cout << "Changing gsdlhome to " << gsdlhome << endl;
+	  std::cout << "Changing gsdlhome to " << gsdlhome << std::endl;
 	  protocol->configure(key, cfgline, error);
 	}
@@ -146,9 +150,9 @@
 	{
 	  // Only let gsdlhome through !!!! // ****
-	  cout << "Supressing httpdomain" << endl;
+	  std::cout << "Supressing httpdomain" << std::endl;
 	}
       else if (key=="httpprefix")
 	{
-	  cout << "Supressing httpprefix" << endl;
+	  std::cout << "Supressing httpprefix" << std::endl;
 	}
       else
@@ -170,5 +174,5 @@
     cct = new corbaconv_text_t(corbaCollect);
 
-    cout << "Collection: " << cct->getcstr() << endl;
+    std::cout << "Collection: " << cct->getcstr() << std::endl;
 
     protocol->has_collection(*cct, _has, err, logout); // 'cct' typecast to text_t
@@ -182,5 +186,5 @@
       }
 
-    // cout << "  " << has << endl;
+    // std::cout << "  " << has << std::endl;
 
     delete cct;
@@ -245,5 +249,5 @@
     logout.close();
     corbaError = (corbaComError) error;
-    cout << "Filter prepared" << corbaResponse.docInfo.length() << "," << corbaResponse.numDocs << endl;
+    std::cout << "Filter prepared" << corbaResponse.docInfo.length() << "," << corbaResponse.numDocs << std::endl;
   }
 
@@ -262,11 +266,11 @@
     protocol->get_collectinfo(collection, response, error, logout);
 
-    cout << "IsPublic  = " << ((response.isPublic)?"True":"False") << endl;
-    cout << "IsBeta    = " << ((response.isBeta)  ?"True":"False") << endl;
-    cout << "BuildDate = " << response.buildDate << endl;
-    cout << "NumDocs   = " << response.numDocs << endl;
-    cout << "NumBytes  = " << response.numBytes << endl;
-    cout << "NumWords  = " << response.numWords << endl;
-    cout << "UseBook   = " << ((response.useBook)  ?"True":"False") << endl;
+    std::cout << "IsPublic  = " << ((response.isPublic)?"True":"False") << std::endl;
+    std::cout << "IsBeta    = " << ((response.isBeta)  ?"True":"False") << std::endl;
+    std::cout << "BuildDate = " << response.buildDate << std::endl;
+    std::cout << "NumDocs   = " << response.numDocs << std::endl;
+    std::cout << "NumBytes  = " << response.numBytes << std::endl;
+    std::cout << "NumWords  = " << response.numWords << std::endl;
+    std::cout << "UseBook   = " << ((response.useBook)  ?"True":"False") << std::endl;
     
     corbaResponse.useBook   = response.useBook;
@@ -280,5 +284,5 @@
     corbaResponse.numWords  = response.numWords;
 
-    corbatext_mapToCorbaMap(response.collectionmeta, &corbaResponse.collectionMeta);
+    corbatext_colmetamapToCorbaColmetamap(response.collectionmeta, &corbaResponse.collectionMeta);
     corbatext_mapToCorbaMap(response.format, &corbaResponse.format);
     corbatext_mapToCorbaMap(response.building, &corbaResponse.building);
@@ -292,5 +296,5 @@
     while (f_here!=f_end)
     {
-      cout << "**** format: " << f_here->first << " = " << f_here->second << endl;
+      std::cout << "**** format: " << f_here->first << " = " << f_here->second << std::endl;
       f_here++;
     } 
@@ -362,5 +366,5 @@
 
     corbaconv_text_t::setCorbatext(collection,corbaCollect);
-    cout << collection.getcstr() << endl;
+    std::cout << collection.getcstr() << std::endl;
 			    
     protocol->get_filterinfo(collection, response, error, logout);
@@ -399,5 +403,5 @@
   void getRssItems (const struct corbatext_t &corbaCollect,
 		  const struct corbatext_t &corbaGsdlHome,
-		  const struct corbatext_t &corbaRssItems,
+		  struct corbatext_t &corbaRssItems,
 		  enum corbaComError &corbaError)
   {   
@@ -416,5 +420,5 @@
     protocol->get_rss_items(collection, gsdlhome, rss_items, error, logout);
     corbaconv_text_t::getCorbatext(rss_items,corbaRssItems);
-
+    
     // decode response
     corbaError = (corbaComError) error;
@@ -433,5 +437,5 @@
     ofstream logout;
 
-    cout << "Received collection list request" << endl;
+    std::cout << "Received collection list request" << std::endl;
 
     this->openLogfile("/etc/corbaout.txt", logout);
@@ -453,12 +457,12 @@
 
     corbatext_arrayToCorbaArray(collist, &corbalist);
-    cout << "Replying " << collist.size() << ": " << endl;
+    std::cout << "Replying " << collist.size() << ": " << std::endl;
 
     for (int unsigned i = 0; i < collist.size(); i ++)
       {
-	cout << collist[i];
-	if (i<collist.size()-1) cout << ", ";
+	std::cout << collist[i];
+	if (i<collist.size()-1) std::cout << ", ";
       }
-    cout << endl;
+    std::cout << std::endl;
 
     logout.close();
@@ -472,46 +476,77 @@
   collectset *cservers;
   text_t     gsdlhome;
-
-  cservers = new collectset(gsdlhome);
+  text_t     collecthome;
+
+  cservers = new collectset(gsdlhome, collecthome);
   protocol.set_collectset(cservers);
 
-  cout << "Started Corba ..." << endl;
+  std::cout << "Started Corba ..." << std::endl;
 
   // ORB initialization
+  // Initialize the ORB
   CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
+
+#if defined(USE_POA)
+  // Obtain a reference to the RootPOA and its Manager
+  CORBA::Object_var poaobj = orb->resolve_initial_references ("RootPOA");
+  PortableServer::POA_var poa = PortableServer::POA::_narrow (poaobj);
+  PortableServer::POAManager_var mgr = poa->the_POAManager();
+#else
   CORBA::BOA_var boa = orb->BOA_init( argc, argv, "mico-local-boa" );
-
-  cout << "Initialised ORB and BOA" << endl;
-
+#endif
+
+  std::cout << "Initialised ORB and P/BOA" << std::endl;
+
+
+  // Create the Server object (the object that inherits from the POA_gsdlInterface::corbaiface
   corbaServer* server = new corbaServer(&protocol, gsdlhome);
 
-  cout << "Initialised server" << endl;
-
-  CORBA::String_var ref = orb->object_to_string( server );
-
-  cout << "Mapped Corba object to string" << endl;
-
+  // Activate the Servant (server)
+#if defined(USE_POA)
+  PortableServer::ObjectId_var oid = poa->activate_object (server);
+#endif
+
+  std::cout << "Initialised server" << std::endl;
+
+  CORBA::Object_var ref = poa->id_to_reference ( oid.in() );
+  CORBA::String_var str = orb->object_to_string( ref.in() );
+
+  std::cout << "Mapped Corba object to string" << std::endl;
+
+  // Write referene to file
   // write id to "naming service"
   ofstream out ("/tmp/localcorba.objid");
 	if (out.is_open()) {
-		out << ref << endl;
+	  	out << str.in() << std::endl;
 		if (out.fail() || out.bad()) {
-			cout << "Failed " << endl;
+			std::cout << "Failed " << std::endl;
 		}
 		out.close ();
 	}
 	else {
-		cout << "Unable to write string to file /tmp/localcorba.objid" << endl;
-		cout << "Please check the file permissions/ownership" << endl;
+	  	std::cout << "Unable to write string" << str.in() << " to file /tmp/localcorba.objid" << std::endl;
+		std::cout << "Please check the file permissions/ownership" << std::endl;
 		return 0;
 	}
-  cout << "Corba string is " << ref << endl;
-
+	std::cout << "Corba string is " << str.in() << std::endl;
+
+	// Activate the POA and start serving requests
   // indicate readiness and run
+#if defined(USE_POA)
+  mgr->activate ();
+  //poa->the_POAManager()->activate();
+#else
   boa->impl_is_ready( CORBA::ImplementationDef::_nil() );
+#endif
   orb->run ();
+
+#if defined(USE_POA)
+  // Shutdown (never reached)
+  poa->destroy (TRUE, TRUE);
+  delete server; // should I include this????
+#else
   CORBA::release( server );
+#endif
   return 0;
 }
 
-
Index: main/trunk/greenstone2/runtime-src/src/corba/corbaiface.idl
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbaiface.idl	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbaiface.idl	(revision 25231)
@@ -23,4 +23,21 @@
   corbatext_tarray values;
 };
+
+// colserver/comtypes.h defines collectionmeta_map of collectionmeta 
+// as (sorted) tuples of: metadata name -> lang -> value
+// However, the C++ definition is: 
+// typedef map<text_t, text_tmap, lttext_t> collectionmeta_map;
+// Where lttext_t is defined to be a sorting function in text_t.h
+// Each collectionmeta name maps to one or more (lang,value) pairs. 
+// The struct below defines the entry for one collectionmeta name.
+struct corbatext_tcollectionmeta {
+  corbatext_t name;
+  corbatext_tmap tuples;
+  //corbatext_tarray languages;
+  //corbatext_tarray values;
+};
+
+typedef sequence<corbatext_tcollectionmeta> corbatext_tcollectionmeta_map;
+
 
 // standard error values
@@ -47,8 +64,9 @@
 struct corbaColInfoResponse
 {
-  boolean       useBook;
-  corbaShortColInfo shoftInfo;
+  corbaShortColInfo shortInfo;
+  boolean           useBook;
   boolean           isPublic;
   boolean           isBeta;
+
   unsigned long     buildDate;
   corbatext_tarray  ccsCols;        // Added 05/04/2000
@@ -57,5 +75,5 @@
   unsigned long     numWords;
   unsigned long     numBytes;
-  corbatext_tmap    collectionMeta;
+  corbatext_tcollectionmeta_map    collectionMeta; //corbatext_tmap    collectionMeta;
   corbatext_tmap    format;
   corbatext_tmap    building;
@@ -63,4 +81,23 @@
   corbatext_t       httpprefix;     // Added 27/07/2000
   corbatext_t       receptionist;
+
+  // The following member fields were added 14/03/2011 to 
+  // match up with ColInfoResponse_t definition in comtypes.h
+
+  boolean isSegmented;
+  boolean isCollectGroup; // used to group a set of collections as one item on the home page
+  unsigned long ccsOptions; // uses CCS #defines from above
+  unsigned long stemIndexes; // uses SI #defines from above
+  unsigned long numSections; // 0 if not known
+  corbatext_tcollectionmeta_map	 collection_macros; // for collectionmacro config directive (> gsdl 2.53)
+  corbatext_t         buildType;           // 'mg' or 'mgpp' or 'lucene'
+  corbatext_t         infodbType;          // 'gdbm', 'sqlite', etc.
+  corbatext_t         authenticate;        // 'document' or 'collection'
+  corbatext_t         auth_group;          // 'mygroup' 'yourgroup'
+  corbatext_tmap      public_documents;    // the acl to allow access to listed documents
+  corbatext_tmap      private_documents;   // the acl to disallow access to listed documents
+  corbatext_tmap      dynamic_classifiers;
+  corbatext_t         earliestDatestamp;   // For OAIserver validation. Time since linux Epoch, expressed as (long) integer value in string form
+
 };
 
@@ -227,10 +264,11 @@
                    inout corbaFilterResponse response,
                    inout corbaComError error);
-  void      get_rss_items (const text_t &collection, 
-			   const text_t &gsdlhome, 
-			   text_t &rss_items, 
-			   comerror_t &err, 
-			   ostream &logout);
-};
-
-};
+
+  void      getRssItems (in corbatext_t collection, 
+			 in corbatext_t gsdlhome, 
+			 inout corbatext_t rss_items, 
+			 inout corbaComError error);
+
+};
+
+};
Index: main/trunk/greenstone2/runtime-src/src/corba/corbaproto.h
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbaproto.h	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbaproto.h	(revision 25231)
@@ -32,4 +32,6 @@
 #include "recptproto.h"
 #include "corbaiface.h"
+
+
 using namespace gsdlInterface;
 
@@ -40,6 +42,6 @@
   collectservermapclass cservers;
   corbaiface_var        client;
-  CORBA::ORB_var        orb;
-  CORBA::BOA_var        boa;
+  //CORBA::ORB_var        orb;
+  //CORBA::BOA_var        boa;
   CORBA::Object_var     obj;
   text_t gsdlhome;
Index: main/trunk/greenstone2/runtime-src/src/corba/corbaproto.mpp
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbaproto.mpp	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbaproto.mpp	(revision 25231)
@@ -26,6 +26,8 @@
  *********************************************************************/
 
-#include <iostream.h>
-#include <fstream.h>
+#define USE_POA
+
+#include <iostream>
+#include <fstream>
 
 #include "fileutil.h"
@@ -63,5 +65,5 @@
       here ++;
     }
-  //  cout << "Options " << i << endl;
+  //  std::cout << "Options " << i << std::endl;
 }
 
@@ -190,5 +192,5 @@
 	    }
 
-	  cout << "Parent " << mi << " " << (int) &mhere->second << " " << (int) mhere->second.parent << endl;
+	  std::cout << "Parent " << mi << " " << (off_t) &mhere->second << " " << (off_t) mhere->second.parent << std::endl;
 
 	  mhere ++;
@@ -308,5 +310,12 @@
 
   CORBA::ORB_var orb = CORBA::ORB_init( dummyc , dummyv, "mico-local-orb" );
-  CORBA::BOA_var boa = orb->BOA_init( dummyc , dummyv, "mico-local-boa" );
+
+#if defined(USE_POA)
+    CORBA::Object_var poaobj = orb->resolve_initial_references ("RootPOA");
+    PortableServer::POA_var poa = PortableServer::POA::_narrow (poaobj);
+    poa->the_POAManager()->activate();
+#else
+    CORBA::BOA_var boa = orb->BOA_init( dummyc , dummyv, "mico-local-boa" );
+#endif
 
   char objid_filename[256];
@@ -344,5 +353,13 @@
   // DB // Try this out!! // ****
   CORBA::ORB_var orb = CORBA::ORB_init( dummyc , dummyv, "mico-local-orb" );
-  CORBA::BOA_var boa = orb->BOA_init( dummyc , dummyv, "mico-local-boa" );
+
+#if defined(USE_POA)
+    CORBA::Object_var poaobj = orb->resolve_initial_references ("RootPOA");
+    PortableServer::POA_var poa = PortableServer::POA::_narrow (poaobj);
+
+    poa->the_POAManager()->activate();
+#else
+    CORBA::BOA_var boa = orb->BOA_init( dummyc , dummyv, "mico-local-boa" );
+#endif
 
   /*  char* site_name_chars = site_name.getcstr();
@@ -375,5 +392,5 @@
   // created
 
-  // cout << "Corbaproto::Configure" << endl;
+  // std::cout << "Corbaproto::Configure" << std::endl;
   corbatext_t      corbaKey;
   corbatext_tarray corbaCfgline;
@@ -403,5 +420,5 @@
 // this init will configure and init each of the collection servers
 bool corbaproto::init (comerror_t &err, ostream &logout) {
-//  cout << "Corbaproto::Init" << endl;
+//  std::cout << "Corbaproto::Init" << std::endl;
   gsdlInterface::corbaComError error = corbaNoError;
 
@@ -426,5 +443,5 @@
       text_t format_line = format_here->second;
 
-      // cout << "*** format line = " << format_line << endl; // ****
+      // std::cout << "*** format line = " << format_line << std::endl; // ****
 
       text_t::iterator fl_begin = format_line.begin();
@@ -494,5 +511,5 @@
 				     ostream &/*logout*/) {
 
-  // cout << "Corbaproto::Collection list" << endl;
+  // std::cout << "Corbaproto::Collection list" << std::endl;
 
   corbatext_tarray corba_collist;
@@ -516,5 +533,5 @@
 void corbaproto::has_collection (const text_t &collection, bool &hascollection, 
 				comerror_t &err, ostream &/*logout*/) {
-  // cout << "Corbaproto::Has collection" << endl;
+  // std::cout << "Corbaproto::Has collection" << std::endl;
 
   corbatext_t     corbaCollection;
@@ -539,5 +556,5 @@
 void corbaproto::ping (const text_t &collection, bool &wassuccess, 
 		      comerror_t &err, ostream &/*logout*/) {
-  // cout << "Corbaproto::Ping" << endl;
+  // std::cout << "Corbaproto::Ping" << std::endl;
 
   corbatext_t corbaCollect;
@@ -558,5 +575,5 @@
   wassuccess = (success != 0);
   err = (comerror_t) corbaError;  
-  cout << "Corbaproto::Ping" << err << endl;
+  std::cout << "Corbaproto::Ping" << err << std::endl;
 }
 
@@ -565,5 +582,5 @@
 				 ColInfoResponse_t &collectinfo,
 				 comerror_t &err, ostream &logout) {
-  //  cout << "Corbaproto::Collectinfo" << endl;
+  //  std::cout << "Corbaproto::Collectinfo" << std::endl;
 
   corbatext_t          corbaCollection;
@@ -591,5 +608,5 @@
   collectinfo.numWords  = corbaCollectInfo.numWords;
   collectinfo.numBytes  = corbaCollectInfo.numBytes;
-  corbatext_corbaMapToMap(corbaCollectInfo.collectionMeta, collectinfo.collectionmeta);
+  corbatext_corbaColmetamapToColmetamap(corbaCollectInfo.collectionMeta, collectinfo.collectionmeta);
   corbatext_corbaMapToMap(corbaCollectInfo.format, collectinfo.format);
   corbatext_corbaMapToMap(corbaCollectInfo.building, collectinfo.building);
@@ -598,4 +615,30 @@
   corbaconv_text_t::setCorbatext(collectinfo.receptionist,corbaCollectInfo.receptionist);
 
+  // Member variables in comtools mirrored in corbaiface (and corbaproto) on 14/03/2012.
+  // shortInfo (previously mistyped as "shoftInfo" in corbaiface.idl) has 3 simple fields
+  corbaconv_text_t::setCorbatext(collectinfo.shortInfo.name, corbaCollectInfo.shortInfo.name);
+  corbaconv_text_t::setCorbatext(collectinfo.shortInfo.host, corbaCollectInfo.shortInfo.host);
+  collectinfo.shortInfo.port = corbaCollectInfo.shortInfo.response;
+  
+  collectinfo.isSegmented = corbaCollectInfo.isSegmented;
+  collectinfo.isCollectGroup = corbaCollectInfo.isCollectGroup;
+
+  collectinfo.numSections = corbaCollectInfo.numSections;
+  collectinfo.ccsOptions = corbaCollectInfo.ccsOptions;
+  collectinfo.stemIndexes = corbaCollectInfo.stemIndexes;
+
+  corbatext_corbaColmetamapToColmetamap(corbaCollectInfo.collection_macros, collectinfo.collection_macros);
+
+  corbaconv_text_t::setCorbatext(collectinfo.buildType,corbaCollectInfo.buildType);
+  corbaconv_text_t::setCorbatext(collectinfo.infodbType,corbaCollectInfo.infodbType);
+  corbaconv_text_t::setCorbatext(collectinfo.authenticate,corbaCollectInfo.authenticate);
+  corbaconv_text_t::setCorbatext(collectinfo.auth_group,corbaCollectInfo.auth_group);
+  corbaconv_text_t::setCorbatext(collectinfo.earliestDatestamp,corbaCollectInfo.earliestDatestamp);
+
+  corbatext_corbaMapToMap(corbaCollectInfo.public_documents, collectinfo.public_documents);
+  corbatext_corbaMapToMap(corbaCollectInfo.private_documents, collectinfo.private_documents);
+  corbatext_corbaMapToMap(corbaCollectInfo.dynamic_classifiers, collectinfo.dynamic_classifiers);
+
+
   cache_missing_icons(collectinfo.format,collectinfo.httpdomain,
 		      collectinfo.httpprefix);
@@ -608,5 +651,5 @@
 				InfoFiltersResponse_t &response,
 				comerror_t &err, ostream &logout) {
-  //  cout << "Corbaproto::Filterinfo" << endl;
+  //  std::cout << "Corbaproto::Filterinfo" << std::endl;
 
   corbatext_t corbaCollection;
@@ -634,5 +677,5 @@
 				   InfoFilterOptionsResponse_t &response, 
 				   comerror_t &err, ostream &logout) {
-  //  cout << "Corbaproto::Filteroptions" << endl;
+  //  std::cout << "Corbaproto::Filteroptions" << std::endl;
 
   corbatext_t corbaCollection;
@@ -688,15 +731,16 @@
   corbaconv_text_t::getCorbatext(collection,corbaCollection);
   corbaconv_text_t::getCorbatext(gsdlhome,corbaGsdlHome);
-  corbaconv_text_t::getCorbatext(rss_items,corbaRssItems);
-
-  // get the corba client reference
-  // corbaiface_var lclient = this->getCorbaClient(); // ****
-  corbaiface_var lclient = client;
-
-  // execute the corba transaction
-  lclient->get_rss_items (corbaCollection, corbaGsdlHome, corbaRssItems, corbaError);
+
+  // get the corba client reference
+  // corbaiface_var lclient = this->getCorbaClient(); // ****
+  corbaiface_var lclient = client;
+
+  // execute the corba transaction
+  lclient->getRssItems (corbaCollection, corbaGsdlHome, corbaRssItems, corbaError);
+
+  err =  (comerror_t) corbaError;
 
   // convert the response back to normal form
-  rss_items = corbaRssItems;
+  corbaconv_text_t::setCorbatext(rss_items,corbaRssItems);
 }
 
@@ -705,5 +749,5 @@
 			  FilterResponse_t &response,
 			  comerror_t &err, ostream &logout) {
-  //  cout << "Corbaproto::Filter" << endl;
+  //  std::cout << "Corbaproto::Filter" << std::endl;
 
   corbaFilterRequest corbaRequest;
@@ -742,5 +786,5 @@
 
   err = (comerror_t) corbaError;
-  //  cout << "Corbaproto::Filter" << endl;
+  //  std::cout << "Corbaproto::Filter" << std::endl;
 }
 
@@ -750,5 +794,5 @@
 			       DocumentResponse_t &response,
 			       comerror_t &err, ostream &logout) {
-  //  cout << "Corbaproto::Get Document" << endl;
+  //  std::cout << "Corbaproto::Get Document" << std::endl;
 
   corbatext_t      corbaCollect;
Index: main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.h
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.h	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.h	(revision 25231)
@@ -1,4 +1,6 @@
+#include "comtypes.h"
+
 void corbatext_fillChar(corbatext_t *t, char *text);
-void corbatext_usvector(corbatext_t t, vector<unsigned short>& us);
+void corbatext_usvector(corbatext_t t, std::vector<unsigned short>& us);
 char *corbatext_string(corbatext_t t);
 #ifdef TEXT_T_H
@@ -12,2 +14,6 @@
 int corbatext_corbatext(text_t t, corbatext_t_var ct);
 #endif
+#ifdef COMTYPES_H
+void corbatext_colmetamapToCorbaColmetamap(collectionmeta_map cm, corbatext_tcollectionmeta_map *ccm);
+void corbatext_corbaColmetamapToColmetamap(corbatext_tcollectionmeta_map ccm, collectionmeta_map &cm);
+#endif
Index: main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.mpp
===================================================================
--- main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.mpp	(revision 25230)
+++ main/trunk/greenstone2/runtime-src/src/corba/corbatext_t.mpp	(revision 25231)
@@ -85,4 +85,6 @@
   ct->encoding = 0;
   cout << "C" << endl;
+
+  return 0;
 }
 
@@ -178,2 +180,52 @@
 }
 
+
+// map of metanames to array(lang, value). So each metaname[i] maps to array (lang, value).
+// Note that corbacollectionmeta_map is an array of pairs
+// each pair consists of (string, map)
+void corbatext_colmetamapToCorbaColmetamap(collectionmeta_map cm, corbatext_tcollectionmeta_map *ccm)
+{
+  collectionmeta_map::iterator here = cm.begin();
+  collectionmeta_map::iterator end  = cm.end();
+  unsigned int i = 0;
+
+  while (here != end)
+    {
+      ccm->length(i+1); // increase size of array of (name, tuples) pairs by 1 each time
+
+      // fill in the metaname field
+      // metaname is of type text_t, get the corbatext value for the text_t key
+      (*ccm)[i].name = *corbatext_corbatext((*here).first); // metaname is of type text_t
+
+      // fill in the tuples field
+      corbatext_mapToCorbaMap((*here).second, &((*ccm)[i].tuples));
+
+      here ++;
+      i ++;
+    }
+
+}
+
+void corbatext_corbaColmetamapToColmetamap(corbatext_tcollectionmeta_map ccm, collectionmeta_map &cm)
+{
+  unsigned int i;
+
+  for (i = 0; i < ccm.length(); i ++) 
+    {
+    // ccm is an array
+    // where each element is a pair of (name, tuples)
+
+    // 1. get the (corba_text_t) name and convert it to text_t
+    text_t* meta_name = new corbaconv_text_t(ccm[i].name);
+
+    corbatext_tmap corbameta_tuples = ccm[i].tuples;
+
+    text_tmap *tuples_map = new text_tmap();
+    corbatext_corbaMapToMap(ccm[i].tuples, *tuples_map);
+
+
+    cm.insert(make_pair(*meta_name,
+    			*tuples_map));			
+    }
+}
+
